## rhonabwy 1.1.11

=== CMakeLists.txt ===
#
# Rhonabwy library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2021-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(rhonabwy C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "JWK, JWKS, JWS, JWE and JWT library")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/rhonabwy/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/rhonabwy/issues")
set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "1")
set(LIBRARY_VERSION_PATCH "11")
set(ORCANIA_VERSION_REQUIRED "2.3.2")
set(YDER_VERSION_REQUIRED "1.4.19")
set(ULFIUS_VERSION_REQUIRED "2.7.13")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(R_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${R_CMAKE_MODULE_PATH}")

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
  set(LIBS ${LIBS} ${JANSSON_LIBRARIES})
  include_directories(${JANSSON_INCLUDE_DIRS})
endif ()

include(FindNettle)
find_package(Nettle REQUIRED)
if (NETTLE_FOUND)
  set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
  include_directories(${NETTLE_INCLUDE_DIRS})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
  set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
  include_directories(${GNUTLS_INCLUDE_DIRS})
endif ()

include(FindZLIB)
find_package(ZLIB REQUIRED)
if (ZLIB_FOUND)
  set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
endif ()

option(WITH_ULFIUS "Use Ulfius library to get HTTP remote content - deprecated, use WITH_CURL instead" ON)
option(WITH_CURL "Use curl library to get HTTP remote content" ON)

if (NOT WITH_ULFIUS)
  message(WARNING "Option WITH_ULFIUS is deprecated, use WITH_CURL instead")
  set(WITH_CURL OFF)
endif ()

if (WITH_CURL)
    include(FindCURL)
    find_package(CURL REQUIRED)
    if (CURL_FOUND)
        set(LIBS ${LIBS} ${CURL_LIBRARIES})
        include_directories(${CURL_INCLUDE_DIRS})
    endif ()
    set(R_WITH_CURL ON)
else ()
    set(R_WITH_CURL OFF)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(RNBYC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/rnbyc)

include_directories(${INC_DIR})

set(LIB_SRC
    ${INC_DIR}/rhonabwy.h # allow many IDEs to find and edit it
    ${SRC_DIR}/misc.c
    ${SRC_DIR}/jwk.c
    ${SRC_DIR}/jwks.c
    ${SRC_DIR}/jws.c
    ${SRC_DIR}/jwe.c
    ${SRC_DIR}/jwt.c)

set(PKGCONF_REQ "")
set(PKGCONF_REQ_PRIVATE "")

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(rhonabwy_static STATIC ${LIB_SRC})
    target_compile_definitions(rhonabwy_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(rhonabwy_static PROPERTIES
            OUTPUT_NAME rhonabwy)
endif ()

# shared library

add_library(rhonabwy SHARED ${LIB_SRC})
set_target_properties(rhonabwy PROPERTIES
        COMPILE_OPTIONS "-Wextra;-Wconversion"
        PUBLIC_HEADER "${INC_DIR}/rhonabwy.h;${PROJECT_BINARY_DIR}/rhonabwy-cfg.h"
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
target_link_libraries(rhonabwy ${LIBS})

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during yder search and download
set(SEARCH_ORCANIA_U OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during ulfius search and download
set(SEARCH_YDER OFF CACHE BOOL "Force to false") # Avoid to search and download yder during ulfius and hoel search and download

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

option(SEARCH_ORCANIA_R "Search for ORCANIA library" ON)
if (SEARCH_ORCANIA_R)
    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
    include(FindOrcania)
    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
    if (NOT ORCANIA_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            download_project(PROJ orcania # ... otherwise, download archive
                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                             QUIET)
            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
            include_directories(${orcania_SOURCE_DIR}/include)
            include_directories(${orcania_BINARY_DIR})
            add_dependencies(yder orcania)
            set(ORCANIA_LIBRARIES orcania)
            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
        else ()
            message( FATAL_ERROR "Orcania not found")
        endif ()
    else()
        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
            include_directories(${ORCANIA_INCLUDE_DIRS})
            include_directories(${orcania_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
        endif ()
    endif ()
else ()
    set(LIBS ${LIBS} orcania)
endif ()

option(SEARCH_YDER_R "Search for YDER library" ON)
if (SEARCH_YDER_R)
    set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
    include(FindYder)
    find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
    if (NOT YDER_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            download_project(PROJ yder # ... otherwise, download archive
                              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
                              QUIET)
            add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
            include_directories(${yder_SOURCE_DIR}/include)
            add_dependencies(ulfius yder)
            set(YDER_LIBRARIES yder orcania)
            include_directories(${yder_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Yder not found")
        endif ()
    else()
        if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
            message(STATUS "Yder found: ${YDER_VERSION_STRING}")
            set(LIBS ${LIBS} ${YDER_LIBRARIES})
            include_directories(${YDER_INCLUDE_DIRS})
            include_directories(${yder_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
        endif ()
    endif ()
    target_link_libraries(rhonabwy ${LIBS} ${YDER_LIBRARIES})
else ()
    set(LIBS ${LIBS} yder)
endif ()

# build rnbyc

option(BUILD_RNBYC "Build rnbyc application." ON)

if (BUILD_RNBYC)
    add_executable(rnbyc ${RNBYC_DIR}/rnbyc.c ${INC_DIR}/rhonabwy.h ${PROJECT_BINARY_DIR}/rhonabwy-cfg.h)
    set_target_properties(rnbyc PROPERTIES SKIP_BUILD_RPATH TRUE COMPILE_OPTIONS "-Wextra;-Wconversion")
    add_dependencies(rnbyc rhonabwy)
    target_link_libraries(rnbyc rhonabwy ${LIBS})
    install(TARGETS rnbyc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES ${RNBYC_DIR}/rnbyc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
endif ()

# documentation

option(BUILD_RHONABWY_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_RHONABWY_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
        
        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
        
        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# build rhonabwy-cfg.h file
configure_file(${INC_DIR}/rhonabwy-cfg.h.in ${PROJECT_BINARY_DIR}/rhonabwy-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# tests

option(BUILD_RHONABWY_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)

if (BUILD_RHONABWY_TESTING)

    set(Ulfius_FIND_QUIETLY ON)
    include(FindUlfius)
    find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} QUIET)
    if (NOT ULFIUS_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            option(CHECK_ORCANIA "specific param" off)
            option(CHECK_YDER "specific param" off)
            message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
            download_project(PROJ ulfius
                             URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
                             QUIET)
            add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
            include_directories(${yder_SOURCE_DIR}/include)
            include_directories(${orcania_SOURCE_DIR}/include)
            include_directories(${ulfius_SOURCE_DIR}/include)
            add_dependencies(rhonabwy ulfius)
            set(ULFIUS_LIBRARIES ulfius)
            include_directories(${ulfius_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Ulfius not found")
        endif ()
    else ()
        if ("${ULFIUS_VERSION_STRING}" VERSION_GREATER_EQUAL "${ULFIUS_VERSION_REQUIRED}")
            message(STATUS "Ulfius found: ${ULFIUS_VERSION_STRING}")
            set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})
            include_directories(${ULFIUS_INCLUDE_DIRS})
            include_directories(${yder_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Ulfius version required: ${ULFIUS_VERSION_REQUIRED} - version installed: ${ULFIUS_VERSION_STRING}")
        endif ()
    endif ()
    target_link_libraries(rhonabwy ${ULFIUS_LIBRARIES})

    include(FindCheck)
    find_package(Check REQUIRED)
    if (CHECK_FOUND)

=== src/Makefile ===
#
# Rhonabwy Library
#
# Makefile used to build the software
#
# Copyright 2020-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=rhonabwy
PROJECT_DESCRIPTION=JWK, JWKS, JWS, JWE and JWT library
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/rhonabwy/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
RHONABWY_INCLUDE=../include
PKGCONFIG_FILE=../librhonabwy.pc
PKGCONFIG_TEMPLATE=../librhonabwy.pc.in
DESTDIR=/usr/local
CONFIG_FILE=$(RHONABWY_INCLUDE)/rhonabwy-cfg.h
CONFIG_TEMPLATE=$(RHONABWY_INCLUDE)/rhonabwy-cfg.h.in
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -Wconversion -D_REENTRANT -I$(RHONABWY_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(LCURL) $(shell pkg-config --libs jansson) $(shell pkg-config --libs gnutls) $(shell pkg-config --libs zlib) $(LDFLAGS)
SONAME=-soname
OBJECTS=jwk.o jwks.o jws.o jwe.o jwt.o misc.o
OUTPUT=librhonabwy.so
VERSION_MAJOR=1
VERSION_MINOR=1
VERSION_PATCH=11

ifdef DISABLE_CURL
R_WITH_CURL=0
else
R_WITH_CURL=1
LCURL=-lcurl
endif

.PHONY: all clean

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        
	@if [ "$(R_WITH_CURL)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine R_WITH_CURL/\#define R_WITH_CURL/g' $(CONFIG_FILE); \
		echo "USE CURL      ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine R_WITH_CURL/\/* #undef R_WITH_CURL *\//g' $(CONFIG_FILE); \
		echo "USE CURL      DISABLED"; \
	fi

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

target: $(OBJECTS)

%.o: %.c $(RHONABWY_INCLUDE)/rhonabwy.h
	$(CC) $(CFLAGS) $<

librhonabwy.so: $(CONFIG_FILE) $(OBJECTS)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(PKGCONFIG_FILE) $(CONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(RHONABWY_INCLUDE)/rhonabwy.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/librhonabwy.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/rhonabwy.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: librhonabwy.so

release: ADDITIONALFLAGS=-O3

release: librhonabwy.so

=== tools/rnbyc/Makefile ===
#
# rnbyc: Rhonabwy command-line tool
#
# Makefile used to build the software
#
# Copyright 2020-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc
RHONABWY_INCLUDE=../../include
RHONABWY_LOCATION=../../src
DESTDIR=/usr/local

CFLAGS+=-Wall -Werror -Wextra -Wconversion -I$(RHONABWY_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-lc -lrhonabwy -lorcania -lyder -ljansson -lgnutls -L$(RHONABWY_LOCATION)
RHONABWY_LIBRARY=../../src/librhonabwy.so
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes
CLAIMS='{"plop":"grut"}'
PASSWORD='RainbowDash'
DPOP="eyJ0eXAiOiJkcG9wK2p3dCIsImFsZyI6IkVTMjU2IiwiandrIjp7Imt0eSI6IkVDIiwieCI6Imw4dEZyaHgtMzR0VjNoUklDUkRZOXpDa0RscEJoRjQyVVFVZldWQVdCRnMiLCJ5IjoiOVZFNGpmX09rX282NHpiVFRsY3VOSmFqSG10NnY5VERWclUwQ2R2R1JEQSIsImNydiI6IlAtMjU2In19.eyJqdGkiOiItQndDM0VTYzZhY2MybFRjIiwiaHRtIjoiUE9TVCIsImh0dSI6Imh0dHBzOi8vc2VydmVyLmV4YW1wbGUuY29tL3Rva2VuIiwiaWF0IjoxNTYyMjYyNjE2fQ.2-GxA6T8lP4vfrg8v-FdWP0A0zdrj8igiMLvqRMUvwnQg4PtFLbdLXiOSsX0x7NVY-FNyJK70nfbV37xRZT3Lg"

all: rnbyc

all: ADDITIONALFLAGS= -O3

clean:
	rm -f *.o rnbyc valgrind-*.txt priv.jwks pub.jwks symkey.jwks token?.jwt

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: rnbyc

$(RHONABWY_LIBRARY):
	cd $(RHONABWY_LOCATION) && $(MAKE) debug

rnbyc: $(RHONABWY_LIBRARY) rnbyc.c
	$(CC) -o rnbyc $(CFLAGS) rnbyc.c $(LIBS)

install: rnbyc
	mkdir -p $(DESTDIR)/bin $(DESTDIR)/man/man1/
	install -m755 rnbyc $(DESTDIR)/bin
	install -m644 rnbyc.1 $(DESTDIR)/man/man1/

uninstall:
	rm -f $(DESTDIR)/bin/rnbyc

manpage: rnbyc
	help2man ./rnbyc -s 1 -n "JWK and JWT parser and generator" > rnbyc.1

test: test-jwks test-serialize test-parse

test-jwks: debug
	# JWKS
	$(VALGRIND_COMMAND) ./rnbyc -h 2>valgrind-01.txt
	$(VALGRIND_COMMAND) ./rnbyc -v 2>valgrind-02.txt
	$(VALGRIND_COMMAND) ./rnbyc --error 2>valgrind-03.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -j -g RSA2048 -o priv.jwks -p pub.jwks 2>valgrind-04.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -f priv.jwks -f pub.jwks 2>valgrind-05.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g oct256 -k "oct-1" -o symkey.jwks 2>valgrind-06.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g EC256 -n 4 2>valgrind-07.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g EC384 -a "plop" -e "grut" 2>valgrind-08.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g Ed25519 2>valgrind-09.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g error 2>valgrind-10.txt || true
	cat priv.jwks | $(VALGRIND_COMMAND) ./rnbyc -j -i 2>valgrind-11.txt
	
test-serialize: debug
	# Serialize JWT
	$(VALGRIND_COMMAND) ./rnbyc -s 'error' 2>valgrind-20.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) 2>valgrind-21.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K symkey.jwks -a HS256 1>token0.jwt 2>valgrind-22.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P pub.jwks 2>valgrind-23.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P pub.jwks -l RSA1_5 1>token1.jwt 2>valgrind-24.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P priv.jwks -l RSA1_5 2>valgrind-25.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P pub.jwks -l RSA-OAEP 1>token4.jwt 2>valgrind-26.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P priv.jwks -l RSA-OAEP 2>valgrind-27.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P pub.jwks -l RSA-OAEP-256 1>token5.jwt 2>valgrind-28.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P priv.jwks -l RSA-OAEP-256 2>valgrind-29.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks 2>valgrind-30.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks -a RS256 1>token2.jwt 2>valgrind-31.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K pub.jwks -a RS256 2>valgrind-32.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks -P pub.jwks -a RS256 -l RSA1_5 1>token3.jwt 2>valgrind-33.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks -P pub.jwks -a RS256 -l RSA-OAEP 1>token6.jwt 2>valgrind-34.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks -P pub.jwks -a RS256 -l RSA-OAEP-256 1>token7.jwt 2>valgrind-35.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K token0.jwt 2>valgrind-36.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P token0.jwt 2>valgrind-37.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -W $(PASSWORD) -l PBES2-HS256+A128KW 1>token8.jwt 2>valgrind-38.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -W $(PASSWORD) -l RSA-OAEP 2>valgrind-39.txt || true

test-parse: debug
	# Parse JWT
	$(VALGRIND_COMMAND) ./rnbyc -t "error" 2>valgrind-40.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token0.jwt) 2>valgrind-41.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) 2>valgrind-42.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -P pub.jwks 2>valgrind-43.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -K priv.jwks 2>valgrind-44.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token2.jwt) 2>valgrind-45.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token2.jwt) -K priv.jwks 2>valgrind-46.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token2.jwt) -P pub.jwks 2>valgrind-47.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) 2>valgrind-48.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) -K priv.jwks 2>valgrind-49.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) -P pub.jwks 2>valgrind-50.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) -P pub.jwks -K priv.jwks 2>valgrind-51.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token4.jwt) 2>valgrind-52.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token4.jwt) -K priv.jwks 2>valgrind-53.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token4.jwt) -P pub.jwks 2>valgrind-54.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token4.jwt) -P pub.jwks -K priv.jwks 2>valgrind-55.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token5.jwt) 2>valgrind-56.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token5.jwt) -K priv.jwks 2>valgrind-57.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token5.jwt) -P pub.jwks 2>valgrind-58.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token5.jwt) -P pub.jwks -K priv.jwks 2>valgrind-59.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token6.jwt) 2>valgrind-60.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token6.jwt) -K priv.jwks 2>valgrind-61.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token6.jwt) -P pub.jwks 2>valgrind-62.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token6.jwt) -P pub.jwks -K priv.jwks 2>valgrind-63.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token7.jwt) 2>valgrind-64.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token7.jwt) -K priv.jwks 2>valgrind-65.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token7.jwt) -P pub.jwks 2>valgrind-66.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token7.jwt) -P pub.jwks -K priv.jwks 2>valgrind-67.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -P pub.jwks -H true -C false 2>valgrind-68.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -P pub.jwks -H false -C false 2>valgrind-69.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token8.jwt) -W $(PASSWORD) 2>valgrind-70.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token8.jwt) -W error 2>valgrind-71.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $DPOP -S 2>valgrind-72.txt || true

=== debian/changelog ===
rhonabwy (1.1.11-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Wed, 08 Feb 2023 18:13:37 -0500

rhonabwy (1.1.10-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/copyright: Update copyright year to 2023 for debian/* files

 -- Nicolas Mora <babelouest@debian.org>  Tue, 10 Jan 2023 07:35:23 -0500

rhonabwy (1.1.9-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:24:03 -0400

=== debian/control ===
Source: rhonabwy
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libgnutls28-dev
             , libjansson-dev
             , zlib1g-dev
             , cmake
             , pkg-config
             , check
             , doxygen
             , gnutls-bin
Standards-Version: 4.6.2
Homepage: https://github.com/babelouest/rhonabwy
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy.git
Rules-Requires-Root: no

Package: librhonabwy1.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: librhonabwy0.9 (<< 0.9.13-4)
Replaces: librhonabwy0.9 (<< 0.9.13-4)
Description: JWK, JWKS, JWS, JWE and JWT library
 Rhonabwy - JWK, JWKS, JWS, JWE and JWT library
 .
  - Create, modify, parse, import or export JSON Web Keys (JWK) and JSON Web
    Keys Set (JWKS)
  - Create, modify, parse, validate or serialize JSON Web Signatures (JWS)
  - Create, modify, parse, validate or serialize JSON Web Encryption (JWE)
    limited and experimental!
  - Create, modify, parse, validate or serialize JSON Web Token (JWT)
 .
 JWT Relies on JWS and JWE functions, so it supports the same functionnalities
 as the other 2. JWT functionnalities also support nesting serilization
 (JWE nested in a JWS or the opposite).

Package: librhonabwy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librhonabwy1.1 (= ${binary:Version}), ${misc:Depends}
       , liborcania-dev
       , libyder-dev
       , libgnutls28-dev
       , libjansson-dev
       , zlib1g-dev
Description: JWK, JWKS, JWS, JWE and JWT library - development
 Rhonabwy - JWK, JWKS, JWS, JWE and JWT library
 .
  - Create, modify, parse, import or export JSON Web Keys (JWK) and JSON Web
    Keys Set (JWKS)
  - Create, modify, parse, validate or serialize JSON Web Signatures (JWS)
  - Create, modify, parse, validate or serialize JSON Web Encryption (JWE)
    limited and experimental!
  - Create, modify, parse, validate or serialize JSON Web Token (JWT)
 .
 JWT Relies on JWS and JWE functions, so it supports the same functionnalities
 as the other 2. JWT functionnalities also support nesting serilization
 (JWE nested in a JWS or the opposite).
 .
 This package contains the development files.

Package: rnbyc
Architecture: any
Depends: ${shlibs:Depends},
       , librhonabwy1.1 (= ${binary:Version})
       , ${misc:Depends}
Description: JWK and JWT parser and generator
 Rhonabwy JWK and JWT parser and generator
 .
  - Generate and/or parse keys and output the result in a JWKS or a
    public/private pair of JWKS files.
  - Parse, decrypt, and/or verify signature of a JWT, using given key
  - Serialize a JWT, the JWT can be signed, encrypted or nested

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    -DBUILD_RHONABWY_TESTING=ON \
	                    -DINSTALL_HEADER=ON \
	                    -DDOWNLOAD_DEPENDENCIES=OFF \
	                    --no-warn-unused-cli

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
	cd build && $(MAKE) test -j1
endif

override_dh_auto_clean:
	rm -rf doc/html test/cert/certtool.log test/cert/*.key test/cert/*.crt
	dh_auto_clean --

=== debian/watch ===
version=4

# https://github.com/babelouest/rhonabwy
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rhonabwy-$1.tar.gz%" \
   https://github.com/babelouest/rhonabwy/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
